package com.engine.organization.mapper.scheme;


import com.engine.organization.entity.scheme.po.GradePO;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/11
 * @Version V1.0
 **/
public interface GradeMapper {

    /**
     * 根据No查询登记方案
     *
     * @param gradeNo
     * @return
     */
    List<GradePO> listByNo(@Param("gradeNo") String gradeNo);

    /**
     * 根据等级方案查询数据
     *
     * @param schemeId
     * @return
     */
    List<GradePO> listGradesBySchemeId(@Param("schemeId") long schemeId);

    /**
     * 获取职级根据ID
     *
     * @param id
     * @return
     */
    GradePO getGradeByID(@Param("id") long id);

    /**
     * 插入职级
     *
     * @param gradePO
     * @return
     */
    int insertIgnoreNull(GradePO gradePO);

    /**
     * 修改，修改所有字段
     *
     * @param gradePO
     * @return
     */
    int updateGrade(GradePO gradePO);

    /**
     * 更新禁用标记
     *
     * @param gradePO
     * @return
     */
    int updateForbiddenTagById(GradePO gradePO);

    /**
     * 批量删除登记方案
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);

    /**
     * 根据禁用标记统计
     *
     * @param tag
     * @return
     */
    int getCountByTag(@Param("tag") int tag);

    List<String> listUsedId();

    List<String> getGradeNameByIds(@Param("ids") Collection<Long> ids);

    @MapKey("id")
    List<Map<String, Object>> listGradessByIds(@Param("ids") Collection<Long> ids);


    GradePO getGradeByLevelId(@Param("levelId") long levelId);


    int checkRepeatNo(@Param("schemeId") Long schemeId, @Param("no") String no, @Param("id") Long id);
}
